<?php

class GjmaaAuctionCategory {

    private $tableName;
    private $wpdb;

    public function __construct(){
        global $wpdb;
        $prefix = $wpdb->prefix;
        $this->tableName = $prefix . "gj_auction_category";
        $this->wpdb = $wpdb;
    }

    public function install(){
        $wpdb = $this->wpdb;
        $tableName = $this->tableName;
        $db_version = "1.0";

        if ($wpdb->get_var("SHOW TABLES LIKE '" . $tableName . "'") != $tableName) {
            $query = "CREATE TABLE " . $tableName . " (
                category_id BIGINT NOT NULL,
                parent_category_id BIGINT NOT NULL,
                name TEXT NOT NULL,
                country_id INT NOT NULL,
                created_at DATETIME NOT NULL,
                PRIMARY KEY (category_id,country_id))
                CHARACTER SET utf8 COLLATE utf8_bin";

            $wpdb->query($query);

            add_option("gjmaa_db_version", $db_version);
        }
    }

    public function uninstall(){
        return $this->wpdb->query('DROP TABLE '.$this->tableName);
    }

    public function installCategories(){
        $apiAllegro = new GjmaaAllegroWebApi();
        $auctions = new GjmaaMyAuctionsAllegro();

        foreach($auctions->getNameOfSite() as $countryId => $site){
            $categories = $apiAllegro->getCategories($countryId);
            if($categories){
                $this->removeAllCategories($countryId);
                $last = count($categories->catsList->item);
                $i = 1;
                $query = '';
                foreach($categories->catsList->item as $index => $category){
                    $query .= $this->prepareSaveCategory($category,$countryId,($i == 1 ? true : false),($i<$last ? false : true));
                    $i++;
                }

                $this->wpdb->query($query);
            }
        }
    }

    public function prepareSaveCategory($category,$countryId = null,$first = false, $last = false){
        return ($first ? 'INSERT INTO ' .
            $this->tableName  .
            ' (category_id, parent_category_id, name, country_id, created_at)'.
            ' VALUES (' : ' (' ) .
            $category->catId.','.
            $category->catParent.',"'.
            addSlashes($category->catName).'",'.
            $countryId . ',"' .
            date('Y-m-d') . ' 00:00:00"' .
            ($last ? '); ' : '), ');
    }

    public function removeAllCategories($countryId = 1){
        return $this->wpdb->query("DELETE FROM ". $this->tableName . " WHERE country_id = ". $countryId);
    }

    public function getCategoryById($id = 0,$countryId = 1){
        return $this->wpdb->get_row("SELECT * FROM " . $this->tableName . " WHERE category_id =" .$id  . " AND country_id = " . $countryId);
    }

    public function getCategoriesByParentCategoryId($parentCategoryId = 0,$countryId = 1)
    {
        return $this->wpdb->get_results("SELECT * FROM " . $this->tableName . " WHERE parent_category_id =" . $parentCategoryId . " AND country_id = " . $countryId . " ORDER BY name ASC");
    }

    public function getCategoryNameById($countryId,$id){
        return $this->wpdb->get_var("SELECT name FROM " . $this->tableName . " WHERE category_id =" .$id  . " AND country_id = " . $countryId);
    }
}
